diff -r f6ef988fda71 trytond/model/modelsql.py
--- a/trytond/model/modelsql.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelsql.py	Sun Sep 23 17:30:03 2012 +0200
@@ -585,27 +578,27 @@
         # all non inherited fields for which there is a get attribute
         fields_post = [x for x in \
                 fields_names + fields_related.keys() + datetime_fields \
-                if x in self._columns \
-                and hasattr(self._columns[x], 'get')]
+                if x in cls._fields \
+                and hasattr(cls._fields[x], 'get')]
         func_fields = {}
         for field in fields_post:
-            if isinstance(self._columns[field], fields.Function):
-                key = (self._columns[field].getter,
-                        getattr(self._columns[field], 'datetime_field', None))
+            if isinstance(cls._fields[field], fields.Function):
+                key = (cls._fields[field].getter,
+                        getattr(cls._fields[field], 'datetime_field', None))
                 func_fields.setdefault(key, [])
                 func_fields[key].append(field)
                 continue
-            if hasattr(self._columns[field], 'datetime_field') \
-                    and self._columns[field].datetime_field:
+            if hasattr(cls._fields[field], 'datetime_field') \
+                    and cls._fields[field].datetime_field:
                 for record in res:
                     with Transaction().set_context(_datetime=record[
-                                self._columns[field].datetime_field]):
-                        res2 = self._columns[field].get([record['id']], self,
+                                cls._fields[field].datetime_field]):
+                        res2 = cls._fields[field].get([record['id']], cls,
                             field, values=[record])
                     record[field] = res2[record['id']]
                 continue
             # get the value of that field for all records/ids
-            res2 = self._columns[field].get(ids, self, field, values=res)
+            res2 = cls._fields[field].get(ids, cls, field, values=res)
             for record in res:
                 record[field] = res2[record['id']]
         for key in func_fields:
@@ -616,12 +609,12 @@
                 for record in res:
                     with Transaction().set_context(
                             _datetime=record[datetime_field]):
-                        res2 = self._columns[field].get([record['id']], self,
+                        res2 = cls._fields[field].get([record['id']], cls,
                                 field_list, values=[record])
                     for field in res2:
                         record[field] = res2[field][record['id']]
                 continue
-            res2 = self._columns[field].get(ids, self, field_list, values=res)
+            res2 = cls._fields[field].get(ids, cls, field_list, values=res)
             for field in res2:
                 for record in res:
                     record[field] = res2[field][record['id']]
@@ -631,24 +624,24 @@
         for field in fields_related.keys() + datetime_fields:
             if field not in fields_names:
                 to_del.add(field)
-            if field not in self._columns:
+            if field not in cls._fields:
                 continue
             if field not in fields_related.keys():
                 continue
             fields_related2values.setdefault(field, {})
-            if self._columns[field]._type in ('many2one', 'one2one'):
-                if hasattr(self._columns[field], 'model_name'):
-                    obj = pool.get(self._columns[field].model_name)
+            if cls._fields[field]._type in ('many2one', 'one2one'):
+                if hasattr(cls._fields[field], 'model_name'):
+                    obj = pool.get(cls._fields[field].model_name)
                 else:
-                    obj = self._columns[field].get_target()
-                if hasattr(self._columns[field], 'datetime_field') \
-                        and self._columns[field].datetime_field:
+                    obj = cls._fields[field].get_target()
+                if hasattr(cls._fields[field], 'datetime_field') \
+                        and cls._fields[field].datetime_field:
                     for record in res:
                         if not record[field]:
                             continue
                         with Transaction().set_context(_datetime=record[
-                                    self._columns[field].datetime_field]):
-                            record2 = obj.read(record[field],
+                                    cls._fields[field].datetime_field]):
+                            record2, = obj.read([record[field]],
                                     fields_related[field])
                         record_id = record2['id']
                         del record2['id']
@@ -664,7 +657,7 @@
                         for record2 in res:
                             fields_related2values[
                                 field][record_id][record2['id']] = record
-            elif self._columns[field]._type == 'reference':
+            elif cls._fields[field]._type == 'reference':
                 for record in res:
                     if not record[field]:
                         continue
@@ -675,17 +668,17 @@
                     if record_id < 0:
                         continue
                     obj = pool.get(model_name)
-                    record2 = obj.read(record_id, fields_related[field])
+                    record2, = obj.read([record_id], fields_related[field])
                     del record2['id']
                     fields_related2values[field][record_id] = record2
 
         if to_del or fields_related.keys() or datetime_fields:
             for record in res:
                 for field in fields_related.keys():
-                    if field not in self._columns:
+                    if field not in cls._fields:
                         continue
                     for related in fields_related[field]:
-                        if self._columns[field]._type in (
+                        if cls._fields[field]._type in (
                                 'many2one', 'one2one'):
                             if record[field]:
                                 record[field + '.' + related] = (
@@ -693,7 +686,7 @@
                                         record[field]][record['id']][related])
                             else:
                                 record[field + '.' + related] = False
-                        elif self._columns[field]._type == 'reference':
+                        elif cls._fields[field]._type == 'reference':
                             if record[field]:
                                 model_name, record_id = record[field].split(
                                         ',', 1)
@@ -708,44 +701,40 @@
                 for field in to_del:
                     del record[field]
 
-        if int_id:
-            return res[0]
         return res
 
-    def write(self, ids, values):
+    @classmethod
+    def write(cls, records, values):
         cursor = Transaction().cursor
         pool = Pool()
-        translation_obj = pool.get('ir.translation')
+        Translation = pool.get('ir.translation')
+        ids = map(int, records)
 
         # Call before cursor cache cleaning
-        trigger_eligibles = self.trigger_write_get_eligibles(
-                isinstance(ids, (int, long)) and [ids] or ids)
+        trigger_eligibles = cls.trigger_write_get_eligibles(records)
 
-        super(ModelSQL, self).write(ids, values)
+        super(ModelSQL, cls).write(records, values)
 
-        if not ids:
+        if not records:
             return True
 
-        if self.table_query():
+        if cls.table_query():
             return True
 
         values = values.copy()
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        else:
-            # _update_tree works if only one record has changed
-            update_tree = False
-            for k in self._columns:
-                field = self._columns[k]
-                if isinstance(field, fields.Many2One) \
-                        and field.model_name == self._name \
-                        and field.left and field.right:
-                    update_tree = True
-            if update_tree:
-                for object_id in ids:
-                    self.write(object_id, values)
-                return True
+        # _update_tree works if only one record has changed
+        update_tree = False
+        for k in cls._fields:
+            field = cls._fields[k]
+            if isinstance(field, fields.Many2One) \
+                    and field.model_name == cls.__name__ \
+                    and field.left and field.right:
+                update_tree = True
+        if update_tree and len(records) > 1:
+            for record in records:
+                cls.write([record], values)
+            return True
 
         if Transaction().timestamp:
             for i in range(0, len(ids), cursor.IN_MAX):
@@ -753,25 +742,26 @@
                 clause = ('(id = %s AND '
                         'CAST(EXTRACT(EPOCH FROM '
                         'COALESCE(write_date, create_date)) AS ' + \
-                        FIELDS['numeric'].sql_type(self.create_date)[1] + \
+                        FIELDS['numeric'].sql_type(cls.create_date)[1] + \
                         ') > %s)')
                 args = []
                 for i in sub_ids:
-                    if Transaction().timestamp.get(self._name + ',' + str(i)):
+                    if Transaction().timestamp.get(
+                            cls.__name__ + ',' + str(i)):
                         args.append(i)
                         args.append(Decimal(Transaction().timestamp[
-                            self._name + ',' + str(i)]))
+                            cls.__name__ + ',' + str(i)]))
                 if args:
                     cursor.execute("SELECT id " \
-                            'FROM "' + self._table + '" ' \
+                            'FROM "' + cls._table + '" ' \
                             'WHERE ' + ' OR '.join(
                                 (clause,) * (len(args) // 2)), args)
                     if cursor.fetchone():
                         raise ConcurrencyException(
                             'Records were modified in the meanwhile')
             for i in ids:
-                if Transaction().timestamp.get(self._name + ',' + str(i)):
-                    del Transaction().timestamp[self._name + ',' + str(i)]
+                if Transaction().timestamp.get(cls.__name__ + ',' + str(i)):
+                    del Transaction().timestamp[cls.__name__ + ',' + str(i)]
 
         # Clean values
         for key in ('create_uid', 'create_date', 'write_uid', 'write_date',
@@ -785,38 +775,38 @@
         updend = []
         direct = []
         for field in values:
-            if field in self._columns:
-                if not hasattr(self._columns[field], 'set'):
-                    if ((not getattr(self._columns[field], 'translate', False))
+            if field in cls._fields:
+                if not hasattr(cls._fields[field], 'set'):
+                    if ((not getattr(cls._fields[field], 'translate', False))
                             or (Transaction().language == CONFIG['language'])):
                         upd0.append(('"' + field + '"', '%s'))
-                        upd1.append(FIELDS[self._columns[field]._type]\
+                        upd1.append(FIELDS[cls._fields[field]._type]\
                                 .sql_format(values[field]))
                     direct.append(field)
                 else:
                     upd_todo.append(field)
             else:
                 updend.append(field)
-            if field in self._columns \
-                    and hasattr(self._columns[field], 'selection') \
-                    and self._columns[field].selection \
+            if field in cls._fields \
+                    and hasattr(cls._fields[field], 'selection') \
+                    and cls._fields[field].selection \
                     and values[field]:
-                if self._columns[field]._type == 'reference':
+                if cls._fields[field]._type == 'reference':
                     if isinstance(values[field], basestring):
                         val = values[field].split(',')[0]
                     else:
                         val, _ = values[field]
                 else:
                     val = values[field]
-                if isinstance(self._columns[field].selection, (tuple, list)):
-                    if val not in dict(self._columns[field].selection):
+                if isinstance(cls._fields[field].selection, (tuple, list)):
+                    if val not in dict(cls._fields[field].selection):
                         raise Exception('ValidateError',
                         'The value "%s" for the field "%s" ' \
                                 'is not in the selection' % \
                                 (val, field))
                 else:
-                    if val not in dict(getattr(self,
-                        self._columns[field].selection)()):
+                    if val not in dict(getattr(cls,
+                        cls._fields[field].selection)()):
                         raise Exception('ValidateError',
                         'The value "%s" for the field "%s" ' \
                                 'is not in the selection' % \
@@ -827,7 +817,7 @@
         upd1.append(Transaction().user)
         upd1.append(datetime.datetime.now())
 
-        domain1, domain2 = pool.get('ir.rule').domain_get(self._name,
+        domain1, domain2 = pool.get('ir.rule').domain_get(cls.__name__,
                 mode='write')
         if domain1:
             domain1 = ' AND (' + domain1 + ') '
@@ -835,37 +825,36 @@
             sub_ids = ids[i:i + cursor.IN_MAX]
             red_sql, red_ids = reduce_ids('id', sub_ids)
             if domain1:
-                cursor.execute('SELECT id FROM "' + self._table + '" ' \
+                cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                         'WHERE ' + red_sql + ' ' + domain1,
                         red_ids + domain2)
             else:
-                cursor.execute('SELECT id FROM "' + self._table + '" ' \
+                cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                         'WHERE ' + red_sql, red_ids)
             rowcount = cursor.rowcount
             if rowcount == -1 or rowcount is None:
                 rowcount = len(cursor.fetchall())
             if not rowcount == len({}.fromkeys(sub_ids)):
                 if domain1:
-                    cursor.execute('SELECT id FROM "' + self._table + '" ' \
+                    cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                             'WHERE ' + red_sql, red_ids)
                     rowcount = cursor.rowcount
                     if rowcount == -1 or rowcount is None:
                         rowcount = len(cursor.fetchall())
                     if rowcount == len({}.fromkeys(sub_ids)):
-                        self.raise_user_error('access_error',
-                                self._description)
-                self.raise_user_error('write_error', self._description)
+                        cls.raise_user_error('access_error', cls.__name__)
+                cls.raise_user_error('write_error', cls.__name__)
             try:
-                cursor.execute('UPDATE "' + self._table + '" '
+                cursor.execute('UPDATE "' + cls._table + '" '
                     'SET ' + ','.join([x[0] + ' = ' + x[1] for x in upd0])
                     + ' WHERE ' + red_sql, upd1 + red_ids)
             except DatabaseIntegrityError, exception:
                 with contextlib.nested(Transaction().new_cursor(),
                         Transaction().set_user(0)):
                     for field_name in values:
-                        if field_name not in self._columns:
+                        if field_name not in cls._fields:
                             continue
-                        field = self._columns[field_name]
+                        field = cls._fields[field_name]
                         # Check required fields
                         if field.required and \
                                 not hasattr(field, 'set') and \
@@ -874,17 +863,17 @@
                                 field_name not in ('create_uid',
                                     'create_date'):
                             if not values[field_name]:
-                                self.raise_user_error('required_field',
-                                        error_args=self._get_error_args(
+                                cls.raise_user_error('required_field',
+                                        error_args=cls._get_error_args(
                                             field_name))
                         if isinstance(field, fields.Many2One) \
                                 and values[field_name]:
-                            model_obj = pool.get(field.model_name)
+                            Model = pool.get(field.model_name)
                             create_records = Transaction().create_records.get(
                                     field.model_name, set())
                             delete_records = Transaction().delete_records.get(
                                     field.model_name, set())
-                            if not ((model_obj.search([
+                            if not ((Model.search([
                                                 ('id', '=',
                                                     values[field_name]),
                                                 ], order=[])
@@ -892,92 +881,93 @@
                                             in create_records))
                                     and (values[field_name]
                                         not in delete_records)):
-                                self.raise_user_error('foreign_model_missing',
-                                    error_args=self._get_error_args(
+                                cls.raise_user_error('foreign_model_missing',
+                                    error_args=cls._get_error_args(
                                         field_name))
-                    for name, _, error in self._sql_constraints:
+                    for name, _, error in cls._sql_constraints:
                         if name in exception[0]:
-                            self.raise_user_error(error)
-                    for name, error in self._sql_error_messages:
+                            cls.raise_user_error(error)
+                    for name, error in cls._sql_error_messages:
                         if name in exception[0]:
-                            self.raise_user_error(error)
+                            cls.raise_user_error(error)
                 raise
 
         for field in direct:
-            if getattr(self._columns[field], 'translate', False):
-                translation_obj.set_ids(
-                        self._name + ',' + field, 'model',
+            if getattr(cls._fields[field], 'translate', False):
+                Translation.set_ids(
+                        cls.__name__ + ',' + field, 'model',
                         Transaction().language, ids, values[field])
 
         # call the 'set' method of fields
         for field in upd_todo:
-            self._columns[field].set(ids, self, field, values[field])
+            cls._fields[field].set(ids, cls, field, values[field])
 
-        if self._history:
-            columns = ['"' + str(x) + '"' for x in self._columns
-                    if not hasattr(self._columns[x], 'set')]
+        if cls._history:
+            columns = ['"' + str(x) + '"' for x in cls._fields
+                    if not hasattr(cls._fields[x], 'set')]
             for obj_id in ids:
-                cursor.execute('INSERT INTO "' + self._table + '__history" ' \
+                cursor.execute('INSERT INTO "' + cls._table + '__history" ' \
                         '(' + ','.join(columns) + ') ' \
                         'SELECT ' + ','.join(columns) + ' ' + \
-                        'FROM "' + self._table + '" ' \
+                        'FROM "' + cls._table + '" ' \
                         'WHERE id = %s', (obj_id,))
 
-        for table in self._inherits:
-            col = self._inherits[table]
-            nids = []
+        for iname in cls._inherits:
+            col = cls._inherits[iname]
+            iids = []
             for i in range(0, len(ids), cursor.IN_MAX):
                 sub_ids = ids[i:i + cursor.IN_MAX]
                 red_sql, red_ids = reduce_ids('id', sub_ids)
                 cursor.execute('SELECT DISTINCT "' + col + '" ' \
-                        'FROM "' + self._table + '" WHERE ' + red_sql,
+                        'FROM "' + cls._table + '" WHERE ' + red_sql,
                         red_ids)
-                nids.extend([x[0] for x in cursor.fetchall()])
+                iids.extend([x[0] for x in cursor.fetchall()])
 
             values2 = {}
             for val in updend:
-                if self._inherit_fields[val][0] == table:
+                if cls._inherit_fields[val][0] == iname:
                     values2[val] = values[val]
             with Transaction().set_user(0, set_context=True):
-                pool.get(table).write(nids, values2)
+                IModel = pool.get(iname)
+                IModel.write(IModel.browse(iids), values2)
 
-        self._validate(ids)
+        cls._validate(records)
 
         # Check for Modified Preorder Tree Traversal
-        for k in self._columns:
-            field = self._columns[k]
+        for k in cls._fields:
+            field = cls._fields[k]
             if isinstance(field, fields.Many2One) \
-                    and field.model_name == self._name \
+                    and field.model_name == cls.__name__ \
                     and field.left and field.right:
                 if field.left in values or field.right in values:
                     raise Exception('ValidateError',
                             'You can not update fields: "%s", "%s"' %
                             (field.left, field.right))
                 if len(ids) == 1:
-                    self._update_tree(ids[0], k, field.left, field.right)
+                    cls._update_tree(ids[0], k, field.left, field.right)
                 else:
                     with Transaction().set_user(0):
-                        self._rebuild_tree(k, False, 0)
+                        cls._rebuild_tree(k, False, 0)
 
-        self.trigger_write(trigger_eligibles)
+        cls.trigger_write(trigger_eligibles)
 
         return True
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, records):
         cursor = Transaction().cursor
         pool = Pool()
+        ids = map(int, records)
+
         if not ids:
             return True
 
-        if self.table_query():
+        if cls.table_query():
             return True
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        if Transaction().delete and Transaction().delete.get(self._name):
+        if Transaction().delete and Transaction().delete.get(cls.__name__):
             ids = ids[:]
-            for del_id in Transaction().delete[self._name]:
+            for del_id in Transaction().delete[cls.__name__]:
                 for i in range(ids.count(del_id)):
                     ids.remove(del_id)
 
@@ -987,34 +977,35 @@
                 clause = ('(id = %s AND '
                         'CAST(EXTRACT(EPOCH FROM '
                         'COALESCE(write_date, create_date)) AS ' + \
-                        FIELDS['numeric'].sql_type(self.create_date)[1] + \
+                        FIELDS['numeric'].sql_type(cls.create_date)[1] + \
                         ') > %s)')
                 args = []
                 for i in sub_ids:
-                    if Transaction().timestamp.get(self._name + ',' + str(i)):
+                    if Transaction().timestamp.get(
+                            cls.__name__ + ',' + str(i)):
                         args.append(i)
                         args.append(Transaction().timestamp[
-                            self._name + ',' + str(i)])
+                            cls.__name__ + ',' + str(i)])
                 if args:
                     cursor.execute("SELECT id "
-                        'FROM "' + self._table + '" '
+                        'FROM "' + cls._table + '" '
                         'WHERE ' + ' OR '.join(
                             (clause,) * (len(args) / 2)), args)
                     if cursor.fetchone():
                         raise ConcurrencyException(
                             'Records were modified in the meanwhile')
             for i in ids:
-                if Transaction().timestamp.get(self._name + ',' + str(i)):
-                    del Transaction().timestamp[self._name + ',' + str(i)]
+                if Transaction().timestamp.get(cls.__name__ + ',' + str(i)):
+                    del Transaction().timestamp[cls.__name__ + ',' + str(i)]
 
         tree_ids = {}
-        for k in self._columns:
-            field = self._columns[k]
+        for k in cls._fields:
+            field = cls._fields[k]
             if isinstance(field, fields.Many2One) \
-                    and field.model_name == self._name \
+                    and field.model_name == cls.__name__ \
                     and field.left and field.right:
                 red_sql, red_ids = reduce_ids('"' + k + '"', ids)
-                cursor.execute('SELECT id FROM "' + self._table + '" '
+                cursor.execute('SELECT id FROM "' + cls._table + '" '
                     'WHERE ' + red_sql, red_ids)
                 tree_ids[k] = [x[0] for x in cursor.fetchall()]
 
@@ -1025,11 +1016,11 @@
             if hasattr(model, 'table_query') \
                     and model.table_query():
                 continue
-            if not isinstance(model, ModelStorage):
+            if not issubclass(model, ModelStorage):
                 continue
-            for field_name, field in model._columns.iteritems():
+            for field_name, field in model._fields.iteritems():
                 if isinstance(field, fields.Many2One) \
-                        and field.model_name == self._name:
+                        and field.model_name == cls.__name__:
                     if field.ondelete == 'CASCADE':
                         foreign_keys_todelete.append((model, field_name))
                     elif field.ondelete == 'SET NULL':
@@ -1040,9 +1031,9 @@
                     else:
                         foreign_keys_tocheck.append((model, field_name))
 
-        Transaction().delete.setdefault(self._name, set()).update(ids)
+        Transaction().delete.setdefault(cls.__name__, set()).update(ids)
 
-        domain1, domain2 = pool.get('ir.rule').domain_get(self._name,
+        domain1, domain2 = pool.get('ir.rule').domain_get(cls.__name__,
                 mode='delete')
         if domain1:
             domain1 = ' AND (' + domain1 + ') '
